/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// graphe non orienté

// les sommets sont les entiers 0,1,...,size-1

#include "prelude.h"
#include "list.h"

#ifndef GRAPH
#define GRAPH

typedef struct Graph graph;

graph *graph_create(int size);
int graph_size(graph *g); // nombre de sommets
void graph_add_edge(graph *g, int u, int v);
bool graph_has_edge(graph *g, int u, int v);
list *graph_succ(graph *g, int u);
void graph_delete(graph *g);

graph *graph_load(char *file);
void graph_print(graph *g);

#endif
